=== debian/changelog ===
apt-cacher-ng (3.7.4-1ubuntu5) noble; urgency=medium

  * No-change rebuild for c-ares t64.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 16 Apr 2024 11:56:04 +0200

apt-cacher-ng (3.7.4-1ubuntu4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:18:00 +1100

apt-cacher-ng (3.7.4-1ubuntu3) noble; urgency=medium

  * No-change rebuild against libevent-2.1-7t64

 -- Simon Chopin <schopin@ubuntu.com>  Fri, 29 Mar 2024 17:19:58 +0100

apt-cacher-ng (3.7.4-1ubuntu2) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 17:22:24 +0000

apt-cacher-ng (3.7.4-1ubuntu1) mantic; urgency=medium

  * d/p/0001-Adjust-HAVE_STRLCPY-macro-check.patch:
    Adjust check of "!HAVE_STRLCPY" for when strlcpy actually
    exists. (LP: #2036822)

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Wed, 20 Sep 2023 16:55:51 -0400

apt-cacher-ng (3.7.4-1build3) mantic; urgency=medium

  * No-change rebuild against libevent-2.1-7

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 19 Sep 2023 19:18:01 +0000

apt-cacher-ng (3.7.4-1build2) kinetic; urgency=medium

  * No-change rebuild against libevent-2.1-7a (LP: 1990941)

 -- Benjamin Drung <bdrung@ubuntu.com>  Fri, 07 Oct 2022 19:31:25 +0200

apt-cacher-ng (3.7.4-1build1) jammy; urgency=medium

  * No-change rebuild to update maintainer scripts, see LP: 1959054

 -- Dave Jones <dave.jones@canonical.com>  Wed, 16 Feb 2022 16:45:54 +0000

apt-cacher-ng (3.7.4-1) unstable; urgency=medium

  * New upstream version
    + avoids reporting garbled Last-Modified date where the information was not
      available (closes: #998329)

 -- Eduard Bloch <blade@debian.org>  Tue, 07 Dec 2021 14:50:20 +0100

apt-cacher-ng (3.7.3-1) unstable; urgency=low

  * New upstream version
    + fixes interpretation of compressed v6 IPs (closes: #994778)
    + adds support for .sig suffix (closes: #989347)
    + fixes compilation with g++-11 (Salsa issue #10)
  * expiring maintenance job execution logs (closes: #985406)

 -- Eduard Bloch <blade@debian.org>  Sat, 09 Oct 2021 12:40:22 +0200

apt-cacher-ng (3.7.2-1) experimental; urgency=high

  * New upstream bugfix release
  * Applying -DCMAKE_SKIP_RPATH=ON for reproducible builds (closes: #989203)

 -- Eduard Bloch <blade@debian.org>  Sun, 30 May 2021 22:35:02 +0200

apt-cacher-ng (3.7.1-1) experimental; urgency=medium

  * New upstream release
    + adds DNS SRV record support (actually closes: #954904)
    + improves skipping over faulty mirrors (mostly since 3.7 which
      closes: #949656), this should also solve old issues (please reopen if
      needed, for now it closes: #787289, #883482, #792541)
    + stops using incorrect date stamps in manually imported files (actually
      fixed in 3.7, closes: #988517)
    + adding cdn-fastly.deb.debian.org as regular mirror (closes: #987394)
    + cleanup references to old tools in the docs (closes: #916296)
  * Added libc-ares-dev as Build-Bependency (FTBFS fix)

 -- Eduard Bloch <blade@debian.org>  Tue, 25 May 2021 20:54:14 +0200

apt-cacher-ng (3.7-1) experimental; urgency=medium

  * New EXPERIMENTAL upstream release
    + various fixes, now this probably really closes: #954904, #986356
    + minor DB generation reproducibility improvement, closes: #988976
    + Limited support of Cache-Control header from clients (no-cache,
      no-store) for LP: #1915713

 -- Eduard Bloch <blade@debian.org>  Sat, 22 May 2021 15:34:07 +0200
