=== client/CMakeLists.txt ===
PROJECT(ACNG CXX C)

INCLUDE_DIRECTORIES(${CMAKE_BINARY_DIR} "${CMAKE_SOURCE_DIR}/src")

ADD_EXECUTABLE(in.acng client.cc ../src/acerrno.cc)
SET_TARGET_PROPERTIES(in.acng PROPERTIES COMPILE_FLAGS "${ACNG_COMPFLAGS} ${ACNG_CXXFLAGS} -DMINIBUILD")
TARGET_LINK_LIBRARIES(in.acng ${NetworkLibs} ${EXTRA_LIBS_INETD})
INSTALL(TARGETS in.acng DESTINATION ${LIBDIR})
