=== debian/changelog ===
apt-cacher-ng (3.7.5-1) unstable; urgency=medium

  * New upstream version
    + redirection location fixes (closes: #1074404)
    + increased safety abort timeout (closes: #1006925)
    + time_t overflow on certain architectures fixed (closes: #1073970)

 -- Eduard Bloch <blade@debian.org>  Mon, 22 Jul 2024 17:34:48 +0200

apt-cacher-ng (3.7.4-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Simplify !defined(HAVE_STRLCPY) check to fix FTBFS (Closes: #1071295)
  * Avoid installing empty /lib/systemd/system directory (Closes: #1059190)

 -- Chris Hofstaedtler <zeha@debian.org>  Tue, 11 Jun 2024 00:41:08 +0200
