=== debian/control ===
--- 
+++ 
@@ -1,9 +1,8 @@
 Source: apt-cacher-ng
 Section: net
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Eduard Bloch <blade@debian.org>
-Build-Depends: debhelper (>= 10), cmake (>= 2.6.2), libbz2-dev, zlib1g-dev, liblzma-dev, libfuse-dev [!hurd-i386], pkg-config, libwrap0-dev, lsb-base (>> 3.0-6), debhelper (>= 9.20160709), po-debconf, libssl-dev, libsystemd-dev (>= 210) [linux-any], libpthread-stubs0-dev, libevent-dev, libc-ares-dev (>> 1.15)
+Maintainer: Eduard Bloch <blade@debian.org>
+Build-Depends: debhelper (>= 10), cmake (>= 3.5), libbz2-dev, zlib1g-dev, liblzma-dev, libfuse-dev [!hurd-i386], pkgconf | pkg-config, libwrap0-dev, sysvinit-utils (>= 3.05-4~) | lsb-base (>> 3.0-6), debhelper (>= 9.20160709), po-debconf, libssl-dev, libsystemd-dev (>= 210) [linux-any], libpthread-stubs0-dev, libevent-dev, libc-ares-dev (>> 1.15)
 Standards-Version: 4.5.1
 Homepage: http://www.unix-ag.uni-kl.de/~bloch/acng/
 Vcs-Git: https://salsa.debian.org/blade/apt-cacher-ng.git
@@ -11,7 +10,7 @@
 
 Package: apt-cacher-ng
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, lsb-base (>= 3.0-6)
+Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, sysvinit-utils (>= 3.05-4~) | lsb-base (>> 3.0-6)
 Pre-Depends: dpkg (>= 1.15.6)
 Conflicts: logrotate (<< 3.8.0)
 Recommends: ca-certificates
